#!/usr/bin/perl -w
# ==============================================================================================
# Author: 	Petri Heinonen & Tommi Lahtonen
# Name: 	laheta.cgi v1.4
# Description: 
# Ohjelma ottaa vastaan WWW-lomakkeelta tulleet tiedot ja lhett ne shkpostitse eteenpin.
# Tiedot lhetetn laheta.conf-tiedostossa kerrottuun osoitteeseen
# Lomakkeen toimintaa voidaan muuttaa muutaman laheta.conf-tiedostossa olevan parametrin avulla
# ==============================================================================================
# v1.2 18.5.2004
# Heitt nyt virheilmoitukset nkyviin WWW-sivulle
# v1.3 22.11.2004
# Listty tiedostoon tallentaminen ja virhetarkistuksia
# Ei lukitse tiedostoa -> jos kaksi kirjoittaa samaan aikaan niin pieleen menee
# v1.31 28.1.2005
# Poistettu turhia varoituksia
# v1.4 10.11.2005
# Muutettu tiedostoon tallennus paremmin SPSS:lle, Excelille ja tietokannoille
# sopivammaksi. Edellytt kuitenkin ksittelya ennen muille ohjelmille
# vienti koska etukteen ei voida tiet montako arvoa millekin
# kentlle tulee joten jokainen arvo on tulostettava omalle rivilleen. Muoto:
# ---------------------------------------
# kentnnimi	arvo
# kentnnimi	arvo
# kentnnimi	arvo
# kentn nimi ja arvo on erotettu tabulaattorilla (\t)
# Nyt tulostaa mys jos samalle nimelle on useita arvoja (esim. checkbox).
# v1.5 13.3.2006
# nyt pitisi kaikki parametrit menn mailiinkin (checkboxit ja multiple-selectit) 
# sorttaus poistettu
 
use CGI::Carp qw(fatalsToBrowser);
use CGI qw(:standard); # Otetaan CGI-kirjasto kyttn.
use XML::DOM;
use XML::DOM::ValParser;
use XML::Encoding;

my $file = "laheta.conf"; # asetustiedoston nimi

# Tulostetaan HTML-sivun alku
sub sivun_alku { 

print header;	# Lhetetn tarvittavat otsikkotiedot selaimelle
print <<HTML_ALKU;
<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1 Strict//EN" 
"http://www.w3.org/TR/2000/REC-xhtml1-20000126/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fi" lang="fi">
<head>
HTML_ALKU

# Tyylilomakkeen lisminen
if ($stylesheet) {
 print '<link rel="StyleSheet" href="',"$stylesheet",'" type="text/css"  />';
}
else {
 print '<link rel="StyleSheet" href="http://appro.mit.jyu.fi/appro2001.css" type="text/css"  />';
}

# Muutetaan title-elementin sislt lomakkeen parametrien mukaisesti
if ($title) { print "<title>$title</title>"; }
else { print "<title>Tilauksesi on otettu vastaan. Kiitokset tilauksestasi!</title>\n"; }

print "</head>";
print "<body><div class=\"main\">";

} #EOsivun_alku 

sub sivun_tiedot { # Tulostetaan lomakkeella annetut tiedot HTML-sivuksi

my($koe)=0; 	# Lokaalimuuttuja
my($arvo)=0; 	# Lokaalimuuttuja

# Muutetaan h1-elementin sislt lomakkeen parametrien mukaisesti
if ($h1) { print "<h1>$h1</h1> \n"; }
else { print "<h1>Kiitokset tilauksestasi</h1> \n"; }

# Muutetaan ensimmisen p-elementin sislt lomakkeen parametrien mukaisesti
if ($p_alku) { print "<p>$p_alku</p> \n"; }
else { print "<p>Kiitokset tilauksestasi! Seuraavassa listassa ovat tilaamasi tuotteet</p> \n"; }

if (!$safe) { print "<p><strong>Lomakkeen tietoja ei voi lhett kyseiseen osoitteeseen! Jos olet tekemss harjoitustyt, niin tarkista ohjelman kyttohjeet. Muussa tapauksessa ota yhteytt Petri Heinoseen (peheinon\@mit.jyu.fi).</strong></p> \n"; }
if (!$email) { print "<p><strong>Lomaketta ei lhetetty shkpostitse!</strong></p> \n"; }


# Kydn lpi lomakkeen tiedot lukuunottamatta parametrej

my @names = param(); 

foreach my $p ( @names ) {

 my @juttu = param($p);
 foreach my $i ( @juttu ) {
#   my $koe= korvaa_merkit($p);  
#   my $arvo = param($i);
   $arvo= korvaa_merkit($i);

   print "<strong>$p</strong>" , ": " , $arvo , "<br /> \n";
 }
}


 
} # EOsivun_tiedot

# Tulostetaan palautesivun loppu
sub sivun_loppu { 

print <<HTML_LOPPU;
</div>
</body>
</html>
HTML_LOPPU

} # EOsivun_loppu


sub mailto { # Lhetetn lomakkeen tiedot shkpostitse

my($koe)=0;     # Lokaalimuuttuja
my($arvo)=0;    # Lokaalimuuttuja
  
if ($email && $safe){ # Jos annettu shkpostiosoite

    if( index($email, '@') < 0  || index($email, '.') < 0) {
    	error_hand(SAHKOPOSTI);
    }
    # Lhetetn varsinainen posti sendmailill 
    open (MAIL,  "|/usr/lib/sendmail -t") or error_hand(MAILTO);
    print MAIL "To: $email\n"; #Lomakkeelta tuleva data

    if ($lahettaja || $nimi) { # Jos annettiin lhettj
    	print MAIL "From: $nimi";
        if($lahettaja) {
    	  print MAIL " \<$lahettaja\>\n";
        }
        else {
    	  print MAIL " \<nobody\@tuntematon.invalid\>\n";
	}
#	print MAIL "\n";
    }    
    else { print MAIL "From: Tuntematon lhettj \<nobody\@tuntematon.invalid\> \n"; } 
  
    if ($otsikko) { # Jos annettiin otsikko
      print MAIL "Subject: $otsikko\n\n";
    } 
    else { print MAIL "Subject: Tilaus\n\n"; } 

foreach $koe (param()) # Kydn lomakkeen tiedot lpi lukuunottamatta parametrej 
{ 
   @arvo= param($koe); 
   foreach my $val ( @arvo ) {
     # Otetaan ylimriset merkit pois
	   $val = korvaa_merkit($val);
     print MAIL "$koe" , ":\t" , $val , "\n\n";
	 }
}
   close (MAIL);
}

} # EOmailto

sub error_hand { #Virheentarkastus
      
  my($temp) = shift(@_);
  my(%errtab) = (
    "MISSMETH", 'Vr metodi!!',
    "MAIL",   	'Shkpostia ei voitu lhett!',
    "SAVE",   	'Tallennustiedosto ei aukea!',
    "SAHKOPOSTI",'Shkpostiosoite on vrin!'
  );
  
  &sivun_alku; #Haetaan HTML-sivun alku

  print "<p>", "\n";
  print "<strong>", "\n";
  print "Sovelluksen suorituksessa tapahtui seuraava virhe:<br><br>", "\n";
 
  print $errtab{$temp},"\n", "<br><br>";
      
  print "Pyri korjaamaan virhe tai ilmoita virheest osoitteeseen: <a href=";
  print '"mailto:tjlahton@mit.jyu.fi">tjlahton@mit.jyu.fi</a>.';
  print "</strong>", "\n";

  &sivun_loppu; # Haetaan HTML-sivun loppu
  exit; # Homma loppuu kokonaan, jos tehdn virhe.
}   

sub korvaa_merkit { # Korvataan ylimriset merkit tyhjll
 
     my ($korvaus) = @_;
#     $korvaus= join(" ", @_);
     
#  $_ =~ s/[;<>\*\|`\$!#\(\)\[\]\{\}:'"+]//g; # Korvataan tietyt merkit
  if ( $korvaus ) {
   $korvaus =~ s/[^\w0-9\@_\.\,\:\-\/\%\~\!\ ]//gi; # Korvataan muut paitsi annetut  
   return($korvaus); 
  }
  return $korvaus;
} 
  
# Varsinainen pohjelma 

# Lomakkeelta tulevia vakiokentti, joiden avulla lomaketta 
# pystytn muokkamaan hieman. Samalla poistetaan ylimriset merkit.
# Globaaleja muuttujia


# my $parser = new XML::DOM::Parser( SkipExternalDTD => 1,
#                                ParseParamEnt=>1, ExpandParamEnt => 0,
#                                ErrorContext=>2, noLWP=>1); 

 my $parser = new XML::DOM::Parser;


my $doc;

eval {

  $doc = $parser->parsefile($file);
};
if ($@) {
  print "Content-Type: text/html; charset=ISO-8859-1\n\n";
  print "<html><head><title>virhe</title></head><body>";
  print "<p><strong>laheta.conf</strong>-tiedostossasi on jotain pahasti vialla. Tarkista tiedoston sislt ja syntaksi!</p>";
  print "<p>Jos et saa virhett korjattua niin lhet seuraava virheilmoitus, conf-tiedostosi sislt sek cgi-ohjelman osoite harjoitustyohjaajallesi!</p>";
  print "<h2>Virheilmoitus</h2>";
  print "<pre>";
  print "$@";
  print "</pre>";
  print "</body></html>";
  exit(1);
}

# $email = $doc->getElementsByTagName("email")->item(0)->getFirstChild->getNodeValue;
 $email = $doc->getElementsByTagName("email")->item(0);
 $title = $doc->getElementsByTagName("title")->item(0);
 $url = $doc->getElementsByTagName("url")->item(0);
 $h1 = $doc->getElementsByTagName("h1")->item(0);
 $p_alku = $doc->getElementsByTagName("p")->item(0);
 $save = $doc->getElementsByTagName("save")->item(0);
 $stylesheet = $doc->getElementsByTagName("css")->item(0);

 $lahettaja = $doc->getElementsByTagName("lahettaja")->item(0);
 $nimi = $doc->getElementsByTagName("nimi")->item(0);
 $otsikko = $doc->getElementsByTagName("otsikko")->item(0);
 
# print $email . "\n";
# print $title . "\n";
# print $url . "\n";
# print $h1 . "\n";
# print $p_alku . "\n";
# print $stylesheet . "\n";


$safe = 1;

if($email->getFirstChild) { 
	$email = $email->getFirstChild->getNodeValue; 
} else { undef $email; }


if(defined($title) && $title->getFirstChild) { $title = $title->getFirstChild->getNodeValue; } else { undef $title; }

if (defined($p_alku) && $p_alku->getFirstChild) { $p_alku = $p_alku->getFirstChild->getNodeValue;} else { undef $p_alku; }

if(defined($url) && $url->getFirstChild) { $url = $url->getFirstChild->getNodeValue; } else { undef $url; }

if(defined($h1) && $h1->getFirstChild) {$h1 = $h1->getFirstChild->getNodeValue;  } else { undef $h1; }

if(defined($save) && $save->getFirstChild) {$save = $save->getFirstChild->getNodeValue;  } else { undef $save; }

if(defined($stylesheet) && $stylesheet->getFirstChild) { $stylesheet = $stylesheet->getFirstChild->getNodeValue;  } else { undef $stylesheet; }

if(defined($lahettaja) && $lahettaja->getFirstChild) { $lahettaja = $lahettaja->getFirstChild->getNodeValue;  } else { undef $lahettaja; }
if(defined($nimi) && $nimi->getFirstChild) { $nimi = $nimi->getFirstChild->getNodeValue;  } else { undef $nimi; }
if(defined($otsikko) && $otsikko->getFirstChild) { $otsikko = $otsikko->getFirstChild->getNodeValue;  } else { undef $otsikko; }


#lomakkeelta tulevat tiedot:

if ( !defined($lahettaja) ) {
 $lahettaja = param("lahettaja");
 $lahettaja =  korvaa_merkit($lahettaja);
}

#if($lahettaja) { $lahettaja =  korvaa_merkit($lahettaja); }

if ( !defined($nimi) ) {
 $nimi = param("nimi");
 $nimi = korvaa_merkit($nimi);
}

if ( !defined($otsikko) ) {
 $otsikko = param("otsikko");
 $otsikko = korvaa_merkit($otsikko);
}

#if($nimi) { $nimi = korvaa_merkit($nimi); }


# Aliohjelmakutsut

mailto() if ( $email); # Lhetetn lomakkeen tiedot shkpostissa.
tallenna($save) if ( $save) ; #tallennetaan tiedot tiedostoon


if (!$url) { # Ei haluta omaa sivua
  &sivun_alku;  
  &sivun_tiedot;
  &sivun_loppu;
}
else { # Halutaan oma sivu
  print "Location: $url\n";
  print "Content-type: text/html\n\n";
}  

# Pohjelman loppu



sub tallenna { # Tallennetaan tiedostoon

my ($save) = @_;

open (SAVE,  ">>$save") or error_hand("SAVE");

print SAVE "--------------------------------------------------------\n";

my $cgi = new CGI;

my @names = $cgi->param();

foreach my $p ( @names ) {

 my @juttu = $cgi->param($p);
 foreach my $i ( @juttu ) {
        print SAVE $p . "\t" . $i . "\n";
 }
}


} 


sub tallenna_old { # Tallennetaan tiedostoon

my ($save) = @_;

my($koe)=0;     # Lokaalimuuttuja
my($arvo)=0;    # Lokaalimuuttuja
  
open (SAVE,  ">>$save") or error_hand("SAVE");

print SAVE "To: $email\n" if ( $email );
print SAVE "From: $nimi" if ( $nimi );
print SAVE "<$lahettaja>\n" if ( $lahettaja );
print SAVE "Subject: $otsikko\n\n" if ( $otsikko );

foreach $koe (param()) # Kydn lomakkeen tiedot lpi lukuunottamatta parametrej 
{ 

   # Otetaan ylimriset merkit pois!
   $koe= korvaa_merkit($koe);
   @arvo= param($koe); 
   @arvo= korvaa_merkit(@arvo); 

    print SAVE "$koe" , ":\t" , @arvo , "\n";
}
   close (SAVE);

} 


